/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * FrmVersao.java
 *
 * Created on 15/01/2011, 17:47:09
 */
package br.com.unimed.importador.cadastro.mascara_de_arquivo.visao;

import br.com.unimed.importador.cadastro.mascara_de_arquivo.controlador.MascaraDeArquivoJpaController;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.controlador.MascaraDeArquivoMascaraDeRegistroJpaController;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.controlador.MascaraDeCampoJpaController;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.controlador.MascaraDeRegistroJpaController;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.controlador.exceptions.PreexistingEntityException;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.persistencia.MascaraDeArquivo;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.persistencia.MascaraDeArquivoMascaraDeRegistro;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.persistencia.MascaraDeArquivoMascaraDeRegistroPK;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.persistencia.MascaraDeArquivoPK;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.persistencia.MascaraDeCampo;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.persistencia.MascaraDeCampoPK;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.persistencia.MascaraDeRegistro;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.persistencia.MascaraDeRegistroPK;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author paulo
 */
public class FrmVersao extends javax.swing.JDialog {

    private Vector<String> versoes;
    private String type = null;
    private int progressContador = 0;
    private boolean notifyEnd = false;

    /** Creates new form FrmVersao */
    public FrmVersao(String versao, Vector<String> versoes,
            String type) {

        initComponents();
        setLocationRelativeTo(null);
        this.versoes = versoes;
        this.type = type;

        jTextVersaoAtual.setText(versao);
        jSpinnerNovaVersao.setValue(Integer.parseInt(versao) + 1);

        if (!versoes.isEmpty()) {

            for (String e : versoes) {
                jComboBoxVersaoAnterior.addItem(e);
            }

            jComboBoxVersaoAnterior.setSelectedIndex(
                    jComboBoxVersaoAnterior.getItemCount() - 1);
        } else {
            chkCopiarVersao.setEnabled(false);

        }

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jLabel1 = new javax.swing.JLabel();
        chkCopiarVersao = new javax.swing.JCheckBox();
        jComboBoxVersaoAnterior = new javax.swing.JComboBox();
        jButtonOk = new javax.swing.JButton();
        jButtonFechar = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jTextVersaoAtual = new javax.swing.JTextField();
        jSpinnerNovaVersao = new javax.swing.JSpinner();
        jProgressBar1 = new javax.swing.JProgressBar();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(br.com.unimed.importador.visao.Main.class).getContext().getResourceMap(FrmVersao.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        chkCopiarVersao.setSelected(true);
        chkCopiarVersao.setText(resourceMap.getString("chkCopiarVersao.text")); // NOI18N
        chkCopiarVersao.setName("chkCopiarVersao"); // NOI18N
        chkCopiarVersao.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                chkCopiarVersaoStateChanged(evt);
            }
        });

        jComboBoxVersaoAnterior.setName("jComboBoxVersaoAnterior"); // NOI18N

        jButtonOk.setText(resourceMap.getString("jButtonOk.text")); // NOI18N
        jButtonOk.setName("jButtonOk"); // NOI18N
        jButtonOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOkActionPerformed(evt);
            }
        });

        jButtonFechar.setText(resourceMap.getString("jButtonFechar.text")); // NOI18N
        jButtonFechar.setName("jButtonFechar"); // NOI18N
        jButtonFechar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonFecharActionPerformed(evt);
            }
        });

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jTextVersaoAtual.setEditable(false);
        jTextVersaoAtual.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextVersaoAtual.setName("jTextVersaoAtual"); // NOI18N

        jSpinnerNovaVersao.setName("jSpinnerNovaVersao"); // NOI18N

        jProgressBar1.setName("jProgressBar1"); // NOI18N
        jProgressBar1.setStringPainted(true);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(12, 12, 12)
                        .addComponent(jLabel2)
                        .addGap(39, 39, 39)
                        .addComponent(jTextVersaoAtual, javax.swing.GroupLayout.PREFERRED_SIZE, 154, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(12, 12, 12)
                        .addComponent(jLabel1)
                        .addGap(40, 40, 40)
                        .addComponent(jSpinnerNovaVersao, javax.swing.GroupLayout.PREFERRED_SIZE, 154, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(12, 12, 12)
                        .addComponent(chkCopiarVersao, javax.swing.GroupLayout.PREFERRED_SIZE, 125, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(2, 2, 2)
                        .addComponent(jComboBoxVersaoAnterior, javax.swing.GroupLayout.PREFERRED_SIZE, 154, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(12, 12, 12)
                        .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 284, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jButtonOk, javax.swing.GroupLayout.PREFERRED_SIZE, 121, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButtonFechar, javax.swing.GroupLayout.PREFERRED_SIZE, 116, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(12, 12, 12))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(25, 25, 25)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(jTextVersaoAtual, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(12, 12, 12)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(5, 5, 5)
                        .addComponent(jLabel1))
                    .addComponent(jSpinnerNovaVersao, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(12, 12, 12)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(chkCopiarVersao)
                    .addComponent(jComboBoxVersaoAnterior, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(19, 19, 19)
                .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonFechar, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButtonOk, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(18, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void chkCopiarVersaoStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_chkCopiarVersaoStateChanged
        // TODO add your handling code here:
        jComboBoxVersaoAnterior.setEnabled(chkCopiarVersao.isSelected());
    }//GEN-LAST:event_chkCopiarVersaoStateChanged

    private void jButtonOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOkActionPerformed
        // TODO add your handling code here:
          jButtonOk.setEnabled(false);

        /* verifica os parametros informados */
        String novaVersao = "";
        try {
            novaVersao = String.valueOf((Integer) jSpinnerNovaVersao.getValue());
        } catch (NumberFormatException e) {
            JOptionPane.showMessageDialog(null, "Informe a versão corretamente",
                    "Entre apenas digitos", JOptionPane.ERROR_MESSAGE);
            jButtonOk.setEnabled(true);
            return;
        }

        if (versoes.contains(novaVersao)) {
            JOptionPane.showMessageDialog(null, "Versão informada já existe",
                    "Digite uma nova versao", JOptionPane.ERROR_MESSAGE);
            jButtonOk.setEnabled(true);
            return;
        }

        execute();
    }//GEN-LAST:event_jButtonOkActionPerformed

    private void jButtonFecharActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonFecharActionPerformed
        // TODO add your handling code here:
        this.dispose();
    }//GEN-LAST:event_jButtonFecharActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JCheckBox chkCopiarVersao;
    private javax.swing.JButton jButtonFechar;
    private javax.swing.JButton jButtonOk;
    private javax.swing.JComboBox jComboBoxVersaoAnterior;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JSpinner jSpinnerNovaVersao;
    private javax.swing.JTextField jTextVersaoAtual;
    // End of variables declaration//GEN-END:variables

    private int getValue() {
        return progressContador;
    }

    private void notifyEventProgress() {
        System.out.println("Disparou");
        final Thread t = new Thread(new Runnable() {

            public void run() {

                while (!getNotifyEnd()) {
                    jProgressBar1.setValue(getValue());
                }

                jProgressBar1.setValue(jProgressBar1.getMaximum());
            }
        });

        if (!t.isAlive()) {
            t.start();
        }

    }

    private boolean getNotifyEnd() {
        return notifyEnd;
    }

    private void setNotifyEnd(boolean notifyEnd) {
        this.notifyEnd = notifyEnd;
    }

    protected void execute() {
      

        notifyEventProgress();

        Thread j = new Thread(new Runnable() {

            @Override
            public void run() {

                if (type.equalsIgnoreCase("MascaraDeArquivo")) {

                    /* inicia o procedimento de cópia */
                    /* primeiro copiar os registros da tabela mascara_de_arquivo */

                    setNotifyEnd(false);
                    progressContador = 0;

                    MascaraDeArquivoJpaController mascaraDeArquivoController =
                            new MascaraDeArquivoJpaController();

                    MascaraDeArquivoMascaraDeRegistroJpaController mascaraArquivoRegistroController =
                            new MascaraDeArquivoMascaraDeRegistroJpaController();

                    MascaraDeRegistroJpaController mascaraRegistroController =
                            new MascaraDeRegistroJpaController();

                    /* obtem list com todas as mascaras de arquivos */
                    List<MascaraDeArquivo> listMascaraDeArquivo =
                            mascaraDeArquivoController.findMascaraDeArquivoEntities();

                    List<MascaraDeRegistro> listMascaraDeRegistro =
                            mascaraRegistroController.findMascaraDeRegistroEntities();

                    /* obtem list com todos os registros mascara_de_arquivo_mascara_registro */
                    List<MascaraDeArquivoMascaraDeRegistro> listMascaraDeArquivoDeRegistro =
                            mascaraArquivoRegistroController.findMascaraDeArquivoMascaraDeRegistroEntities();

                    /* obtem o iterator para navegar nos elementos da list */
                    Iterator<MascaraDeArquivoMascaraDeRegistro> iteratorMascaraDeArquivoRegistro =
                            listMascaraDeArquivoDeRegistro.listIterator();


                    /* obtem o iterator para navegar nos elementos da list */
                    Iterator<MascaraDeArquivo> iteratorMascaraDeArquivo =
                            listMascaraDeArquivo.listIterator();

                    /* obtem o iterator para navegar nos elementos da list */
                    Iterator<MascaraDeRegistro> iteratorMascaraDeRegistro =
                            listMascaraDeRegistro.listIterator();

                    /* usado para receber o elemento da list e processar */
                    MascaraDeArquivo mascaraDeArquivo = null;
                    MascaraDeArquivoMascaraDeRegistro mascaraDeArquivoMascaraDeRegistro = null;
                    MascaraDeRegistro mascaraDeRegistro = null;

                    /* Esse laço deixa apenas as mascaras de arquivos da
                     * versão selecionada
                     */
                    while (iteratorMascaraDeArquivo.hasNext()) {
                        mascaraDeArquivo = iteratorMascaraDeArquivo.next();
                        if (mascaraDeArquivo.getMascaraDeArquivoPK().getNumVersaoMascaraDeArquivo()
                                != Short.parseShort((String) jComboBoxVersaoAnterior.getSelectedItem())) {
                            iteratorMascaraDeArquivo.remove();
                        }


                    }


                    /* Esse laço deixa apenas as mascaras_de_arquivo_mascara_de_registro
                     * versão selecionada
                     */
                    while (iteratorMascaraDeArquivoRegistro.hasNext()) {
                        mascaraDeArquivoMascaraDeRegistro = iteratorMascaraDeArquivoRegistro.next();
                        if (mascaraDeArquivoMascaraDeRegistro.getMascaraDeArquivoMascaraDeRegistroPK().getNumVersaoMascaraDeArquivo()
                                != Short.parseShort((String) jComboBoxVersaoAnterior.getSelectedItem())) {
                            iteratorMascaraDeArquivoRegistro.remove();
                        }
                    }

                    /* Esse laço deixa apenas as mascaras_de_registro
                     * versão selecionada
                     */
                    while (iteratorMascaraDeRegistro.hasNext()) {
                        mascaraDeRegistro = iteratorMascaraDeRegistro.next();
                        if (mascaraDeRegistro.getMascaraDeRegistroPK().getNumVersaoMascaraDeRegistro()
                                != Short.parseShort((String) jComboBoxVersaoAnterior.getSelectedItem())) {
                            iteratorMascaraDeRegistro.remove();
                        }
                    }


                    /* As duas list envolvidas na operação contém apenas o número da versão
                     * que deve ser copiada. Inserir os registros copiados alterando o número
                     * da versão de acordo com o especificado pelo usuário
                     */

                    iteratorMascaraDeArquivo = listMascaraDeArquivo.listIterator();
                    iteratorMascaraDeArquivoRegistro = listMascaraDeArquivoDeRegistro.listIterator();
                    iteratorMascaraDeRegistro = listMascaraDeRegistro.listIterator();

                    int maximo = (listMascaraDeArquivo.size()
                            + listMascaraDeArquivoDeRegistro.size()
                            + listMascaraDeRegistro.size()) * 2;

                    jProgressBar1.setMaximum(maximo);

                    /* Copiando e criando novos registros */
                    while (iteratorMascaraDeArquivo.hasNext()) {
                        mascaraDeArquivo = iteratorMascaraDeArquivo.next();

                        progressContador++;

                        MascaraDeArquivoPK MascaraDeArquivoPkTmp = mascaraDeArquivo.getMascaraDeArquivoPK();
                        MascaraDeArquivoPkTmp.setNumVersaoMascaraDeArquivo(
                                ((Integer) jSpinnerNovaVersao.getValue()).shortValue());

                        mascaraDeArquivo.setMascaraDeArquivoPK(MascaraDeArquivoPkTmp);
                        try {
                            mascaraDeArquivoController.create(mascaraDeArquivo);
                        } catch (PreexistingEntityException ex) {
                            Logger.getLogger(FrmVersao.class.getName()).log(Level.SEVERE, null, ex);
                            JOptionPane.showMessageDialog(null, "Operação de cópia abortada",
                                    "Duplicação detectada", JOptionPane.ERROR_MESSAGE);
                            return;
                        } catch (Exception ex) {
                            Logger.getLogger(FrmVersao.class.getName()).log(Level.SEVERE, null, ex);
                            JOptionPane.showMessageDialog(null, "Operação de cópia abortada",
                                    "Excessão ocorreu na inserção de registros",
                                    JOptionPane.ERROR_MESSAGE);
                            return;

                        }


                    }


                    /// laço while para criar as mascaras de registros ///

                    while (iteratorMascaraDeRegistro.hasNext()) {
                        /* Criar a mascara de Registro */
                        mascaraDeRegistro = iteratorMascaraDeRegistro.next();
                        MascaraDeRegistro mascaraRegistroTmp;

                        progressContador++;

                        try {

                            if (mascaraRegistroController.findMascaraDeRegistro(new MascaraDeRegistroPK(mascaraDeRegistro.getMascaraDeRegistroPK().
                                    getCodMascaraDeRegistro(),
                                    ((Integer) jSpinnerNovaVersao.getValue()).shortValue())) != null) {
                                /* já está cadastrada */
                                continue;
                            }

                            mascaraRegistroTmp = new MascaraDeRegistro(new MascaraDeRegistroPK(mascaraDeRegistro.getMascaraDeRegistroPK().
                                    getCodMascaraDeRegistro(),
                                    ((Integer) jSpinnerNovaVersao.getValue()).shortValue()));

                            mascaraRegistroTmp.setDscMascaraDeRegistro(mascaraDeRegistro.getDscMascaraDeRegistro());
                            mascaraRegistroTmp.setVlrTamanho(mascaraDeRegistro.getVlrTamanho());

                            mascaraRegistroController.create(mascaraRegistroTmp);
                        } catch (PreexistingEntityException ex) {
                            Logger.getLogger(FrmVersao.class.getName()).log(Level.SEVERE, null, ex);
                        } catch (Exception ex) {
                            Logger.getLogger(FrmVersao.class.getName()).log(Level.SEVERE, null, ex);
                        }

                    }

                    /* Copiando e criando novos registros */
                    while (iteratorMascaraDeArquivoRegistro.hasNext()) {
                        mascaraDeArquivoMascaraDeRegistro = iteratorMascaraDeArquivoRegistro.next();

                        progressContador++;

                        MascaraDeArquivoMascaraDeRegistroPK MascaraDeArquivoRegistroPK =
                                mascaraDeArquivoMascaraDeRegistro.getMascaraDeArquivoMascaraDeRegistroPK();

                        MascaraDeArquivoRegistroPK.setNumVersaoMascaraDeArquivo(
                                ((Integer) jSpinnerNovaVersao.getValue()).shortValue());
                        MascaraDeArquivoRegistroPK.setNumVersaoMascaraDeRegistro(
                                ((Integer) jSpinnerNovaVersao.getValue()).shortValue());

                        mascaraDeArquivoMascaraDeRegistro.setMascaraDeArquivoMascaraDeRegistroPK(MascaraDeArquivoRegistroPK);


                        MascaraDeArquivo mascaraDeArquivoTmp = new MascaraDeArquivo(
                                new MascaraDeArquivoPK(
                                mascaraDeArquivoMascaraDeRegistro.getMascaraDeArquivo().
                                getMascaraDeArquivoPK().getCodMascaraDeArquivo(),
                                ((Integer) jSpinnerNovaVersao.getValue()).shortValue()));

                        mascaraDeArquivoTmp.setDscMascaraDeArquivo(mascaraDeArquivoMascaraDeRegistro.getMascaraDeArquivo().getDscMascaraDeArquivo());

                        mascaraDeArquivoMascaraDeRegistro.setMascaraDeArquivo(mascaraDeArquivoTmp);


                        MascaraDeRegistro mascaraDeRegistroTmp = new MascaraDeRegistro(
                                new MascaraDeRegistroPK(
                                mascaraDeArquivoMascaraDeRegistro.getMascaraDeRegistro().
                                getMascaraDeRegistroPK().getCodMascaraDeRegistro(),
                                ((Integer) jSpinnerNovaVersao.getValue()).shortValue()));

                        mascaraDeRegistroTmp.setDscMascaraDeRegistro(mascaraDeArquivoMascaraDeRegistro.getMascaraDeRegistro().getDscMascaraDeRegistro());

                        mascaraDeArquivoMascaraDeRegistro.setMascaraDeRegistro(mascaraDeRegistroTmp);

                        try {
                            mascaraArquivoRegistroController.create(mascaraDeArquivoMascaraDeRegistro);
                        } catch (PreexistingEntityException ex) {
                            Logger.getLogger(FrmVersao.class.getName()).log(Level.SEVERE, null, ex);
                            JOptionPane.showMessageDialog(null, "Operação de cópia abortada",
                                    "Duplicação detectada", JOptionPane.ERROR_MESSAGE);
                            return;
                        } catch (Exception ex) {
                            Logger.getLogger(FrmVersao.class.getName()).log(Level.SEVERE, null, ex);
                            JOptionPane.showMessageDialog(null, "Operação de cópia abortada",
                                    "Excessão ocorreu na inserção de registros",
                                    JOptionPane.ERROR_MESSAGE);
                            return;
                        }
                    }

                    setNotifyEnd(true);

                    JOptionPane.showMessageDialog(null, "Sucesso!",
                            "Sucesso na cópia", JOptionPane.INFORMATION_MESSAGE);

                } else if (type.equalsIgnoreCase("MascaraDeRegistro")) {

                    setNotifyEnd(false);
                    progressContador = 0;

                    MascaraDeRegistroJpaController mascaraRegistroController =
                            new MascaraDeRegistroJpaController();

                    MascaraDeCampoJpaController mascaraDeCampoController =
                            new MascaraDeCampoJpaController();


                    List<MascaraDeRegistro> listMascaraDeRegistro =
                            mascaraRegistroController.findMascaraDeRegistroEntities();

                    List<MascaraDeCampo> listMascaraDeCampo =
                            mascaraDeCampoController.findMascaraDeCampoEntities();

                    /* obtem o iterator para navegar nos elementos da list */
                    Iterator<MascaraDeRegistro> iteratorMascaraDeRegistro =
                            listMascaraDeRegistro.listIterator();

                    Iterator<MascaraDeCampo> iteratorMascaraDeCampo =
                            listMascaraDeCampo.listIterator();




                    MascaraDeRegistro mascaraDeRegistro = null;
                    MascaraDeCampo mascaraDeCampo = null;

                    /* Esse laço deixa apenas as mascaras_de_registro
                     * versão selecionada
                     */
                    while (iteratorMascaraDeRegistro.hasNext()) {
                        mascaraDeRegistro = iteratorMascaraDeRegistro.next();
                        if (mascaraDeRegistro.getMascaraDeRegistroPK().getNumVersaoMascaraDeRegistro()
                                != Short.parseShort((String) jComboBoxVersaoAnterior.getSelectedItem())) {
                            iteratorMascaraDeRegistro.remove();
                        }
                    }

                    while (iteratorMascaraDeCampo.hasNext()) {
                        mascaraDeCampo = iteratorMascaraDeCampo.next();
                        if (mascaraDeCampo.getMascaraDeCampoPK().getNumVersaoMascaraDeRegistro()
                                != Short.parseShort((String) jComboBoxVersaoAnterior.getSelectedItem())) {
                            iteratorMascaraDeCampo.remove();
                        }
                    }

                    iteratorMascaraDeRegistro = listMascaraDeRegistro.listIterator();
                    iteratorMascaraDeCampo = listMascaraDeCampo.listIterator();

                    int maximo = (listMascaraDeCampo.size()
                            + listMascaraDeRegistro.size());

                    jProgressBar1.setMaximum(maximo);

                    /// laço while para criar as mascaras de registros se for necessário ///
                    while (iteratorMascaraDeRegistro.hasNext()) {
                        /* Criar a mascara de Registro */
                        mascaraDeRegistro = iteratorMascaraDeRegistro.next();
                        MascaraDeRegistro mascaraRegistroTmp;
                        progressContador++;

                        try {
                            if (mascaraRegistroController.findMascaraDeRegistro(new MascaraDeRegistroPK(mascaraDeRegistro.getMascaraDeRegistroPK().
                                    getCodMascaraDeRegistro(),
                                    ((Integer) jSpinnerNovaVersao.getValue()).shortValue())) != null) {
                                /* já está cadastrada */
                                continue;
                            }

                            mascaraRegistroTmp = new MascaraDeRegistro(new MascaraDeRegistroPK(mascaraDeRegistro.getMascaraDeRegistroPK().
                                    getCodMascaraDeRegistro(),
                                    ((Integer) jSpinnerNovaVersao.getValue()).shortValue()));

                            mascaraRegistroTmp.setDscMascaraDeRegistro(mascaraDeRegistro.getDscMascaraDeRegistro());
                            mascaraRegistroTmp.setVlrTamanho(mascaraDeRegistro.getVlrTamanho());

                            mascaraRegistroController.create(mascaraRegistroTmp);
                        } catch (PreexistingEntityException ex) {
                            Logger.getLogger(FrmVersao.class.getName()).log(Level.SEVERE, null, ex);
                        } catch (Exception ex) {
                            Logger.getLogger(FrmVersao.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                    /* procedimento de cópia para os campos de registros */
                    while (iteratorMascaraDeCampo.hasNext()) {
                        progressContador++;
                        mascaraDeCampo = iteratorMascaraDeCampo.next();

                        MascaraDeCampoPK mascaraDeCampoPK = mascaraDeCampo.getMascaraDeCampoPK();
                        mascaraDeCampoPK.setNumVersaoMascaraDeRegistro(
                                ((Integer) jSpinnerNovaVersao.getValue()).shortValue());

                        mascaraDeCampo.setMascaraDeCampoPK(mascaraDeCampoPK);

                        MascaraDeRegistro mascaraDeRegistroTmp = new MascaraDeRegistro(
                                new MascaraDeRegistroPK(
                                mascaraDeCampo.getMascaraDeRegistro().
                                getMascaraDeRegistroPK().getCodMascaraDeRegistro(),
                                ((Integer) jSpinnerNovaVersao.getValue()).shortValue()));

                        mascaraDeRegistroTmp.setDscMascaraDeRegistro(mascaraDeCampo.getMascaraDeRegistro().getDscMascaraDeRegistro());
                        mascaraDeCampo.setMascaraDeRegistro(mascaraDeRegistroTmp);


                        try {
                            mascaraDeCampoController.create(mascaraDeCampo);
                        } catch (PreexistingEntityException ex) {
                            Logger.getLogger(FrmVersao.class.getName()).log(Level.SEVERE, null, ex);
                        } catch (Exception ex) {
                            Logger.getLogger(FrmVersao.class.getName()).log(Level.SEVERE, null, ex);
                        }

                    }

                    setNotifyEnd(true);

                    JOptionPane.showMessageDialog(null, "Sucesso!",
                            "Sucesso na cópia", JOptionPane.INFORMATION_MESSAGE);
                }


            }
        });

        if (!j.isAlive()) {
            j.start();
        }

        jButtonOk.setEnabled(true);
    }
}
